(*
Delphi 7 unit for the libfaad2 Wrapper Filter (LWF)
Copyright 2007-2008 Griga (http://www.dvbviewer.com)
Contact me via http://www.dvbviewer.info/forum/

This file is part of the LWF 1.1.3 source code.

    The LWF is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    The LWF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with the LWF. If not, see <http://www.gnu.org/licenses/>.
*)

unit UFilterData;
//contains const declarations for the libfaad Wrapper Filter

interface

uses
  MMSystem, DirectShow9;
  //DirectShow9 is part of the DSPack (Borland Delphi API for Direct Show).
  //Available from http://www.progdigy.com

const
  InvalidClock = $8000000000000000;

  faad2WrapperName = 'libfaad2 Wrapper';

  sCLSID_faad2Wrapper = '{30D1CB1E-5615-4450-8A88-48719D96DB26}';

  sMEDIATYPE_AUDIO =  '{73647561-0000-0010-8000-00AA00389B71}';
  sMEDIASUBTYPE_PCM = '{00000001-0000-0010-8000-00AA00389B71}';
  sFORMAT_WAVEFORMATEX = '{05589F81-C356-11CE-BF01-00AA0055595A}';
  sKSDATAFORMAT_SUBTYPE_PCM = '{00000001-0000-0010-8000-00aa00389b71}';

  sMEDIASUBTYPE_AAC = '{000000FF-0000-0010-8000-00AA00389B71}';  //AAC /raw and ADTS)
  sMEDIASUBTYPE_LATM_AAC = '{000001FF-0000-0010-8000-00AA00389B71}'; //LATM AAC (Elecard Demux)

  CLSID_faad2Wrapper: TGUID = sCLSID_faad2Wrapper;

  MEDIASUBTYPE_AAC: TGUID = sMEDIASUBTYPE_AAC;
  MEDIASUBTYPE_LATM_AAC: TGUID = sMEDIASUBTYPE_LATM_AAC;

  //output format type template
  OutputType: AM_MEDIA_TYPE =
  (
    majortype:            sMEDIATYPE_AUDIO;
    subtype:              sMEDIASUBTYPE_PCM;
    bFixedSizeSamples:    false;
    bTemporalCompression: false;
    lSampleSize:          0;
    formattype:           sFORMAT_WAVEFORMATEX;
    pUnk:                 nil;
    cbFormat:             0;
    pbFormat:             nil;
  );

  //the preferred input media types
  AACPinTypes: array[0..1] of TRegPinTypes =
  (
    (clsMajorType: @MEDIATYPE_Audio;
     clsMinorType: @MEDIASUBTYPE_AAC),
    (clsMajorType: @MEDIATYPE_Audio;
     clsMinorType: @MEDIASUBTYPE_LATM_AAC)
  );

  //the preferred output media types
  PCMPinTypes: array[0..0] of TRegPinTypes =
  (
    (clsMajorType: @MEDIATYPE_Audio;
     clsMinorType: @MEDIASUBTYPE_PCM)
  );

  //the pins
  AACPins: array[0..1] of TRegFilterPins =
  (
    ( //input pin
    strName: 'XForm In'; // Pins string name
    bRendered: FALSE; // Is it rendered
    bOutput: FALSE; // Is it an output
    bZero: FALSE; // Are we allowed none
    bMany: FALSE; // And allowed many
    oFilter: nil; // Connects to filter
    strConnectsToPin: nil; // Connects to pin
    nMediaTypes: Length(AACPinTypes); // Number of types
    lpMediaType: @AACPinTypes // Pin information
    ),
    ( //output pin
    strName: 'XForm Out'; // Pins string name
    bRendered: FALSE; // Is it rendered
    bOutput: TRUE; // Is it an output
    bZero: FALSE; // Are we allowed none
    bMany: FALSE; // And allowed many
    oFilter: nil; // Connects to filter
    strConnectsToPin: nil; // Connects to pin
    nMediaTypes: Length(PCMPinTypes); // Number of types
    lpMediaType: @PCMPinTypes // Pin information
    )
  );

implementation

end.
